grid2d_Grid

	//==========================================================================
	var
		list/grid2d_cells
		grid2d_X	= 1

	//==========================================================================
	//--------------------------------------------------------------------------
	//	If Width is a Grid, this becomes a copy constructor and the rest is ignored.
	New(Width=1,Height=1,DefaultValue=null)
		src.grid2d_Reset(Width,Height,DefaultValue)

	//--------------------------------------------------------------------------
	Del()
		if (src.grid2d_cells)	src.grid2d_cells.Cut()
		..()

	//==========================================================================
	proc
		//----------------------------------------------------------------------
		//	Turns the grid into a copy of Grid.
		grid2d_CopyIntoSelf(grid2d_Grid/Grid)
			if ( !istype(Grid) )	return FALSE
			src.grid2d_X			= Grid.grid2d_X
			src.grid2d_cells		= Grid.grid2d_cells.Copy()
			src.grid2d_nDirs		= Grid.grid2d_nDirs
			src.grid2d_wrap			= Grid.grid2d_wrap
			return TRUE

		//----------------------------------------------------------------------
		//	Sets the grid dimensions to Width by Height and makes DefaultValue
		//	the item stored in every cell.  If Width is a grid2d_Grid, its values
		//	will be used and the other arguments will be ignored.
		//	Returns:
		//		0 on failure
		//		negative if the result is a copy.
		//		positive if the result is not a copy
		grid2d_Reset(Width=1,Height=1,DefaultValue=null)
			if ( src.grid2d_CopyIntoSelf(Width) )	return -1
			.										= 1
			if ( !isnum(Width) || (Width<1) )	src.grid2d_X		= 1
			else								src.grid2d_X		= round(Width)
			if ( !isnum(Height) || (Height<1) )	Height				= 1
			else								Height				= round(Height)
			if (src.grid2d_cells)				src.grid2d_cells.Cut()
			else								src.grid2d_cells	= list()
			src.grid2d_cells.len				= src.grid2d_X*Height
			if ( !isnull(DefaultValue) )
				for( Width = 1 to src.grid2d_cells.len )
					src.grid2d_cells[Width]		= DefaultValue
