grid2d_Grid

	//==========================================================================
	proc
		//----------------------------------------------------------------------
		//	Returns the distance between the coordinates X1,Y1 and X2,Y2.
		//	Returns negative on failure.
		//----------------------------------------------------------------------
		grid2d_GetDist(X1,Y1,X2,Y2)
			if ( !isnum(X1) || !isnum(Y1) || !isnum(X2) || !isnum(Y2) )	return -1
			return max(src.grid2d_GetDistX(X1,Y1,X2,Y2),src.grid2d_GetDistY(X1,Y1,X2,Y2))

		//----------------------------------------------------------------------
		//	Returns the horizontal distance between the coordinates X1,Y1 and X2,Y2.
		//	Returns negative on failure.
		grid2d_GetDistX(X1,Y1,X2,Y2)
			if ( !isnum(X1) || !isnum(Y1) || !isnum(X2) || !isnum(Y2) )	return -1
			.								= abs(X2-X1)
			if ( src.grid2d_DoesWrapX() )	.	= min( . , src.grid2d_GetMaxX() - . )

		//----------------------------------------------------------------------
		//	Returns the horizontal distance between the coordinates X1,Y1 and X2,Y2.
		//	Returns negative on failure.
		grid2d_GetDistY(X1,Y1,X2,Y2)
			if ( !isnum(X1) || !isnum(Y1) || !isnum(X2) || !isnum(Y2) )	return -1
			.								= abs(Y2-Y1)
			if ( src.grid2d_DoesWrapY() )	.	= min( . , src.grid2d_GetMaxY() - . )

		//----------------------------------------------------------------------
		//	Returns the width of the grid.
		grid2d_GetMaxX()
			return src.grid2d_X

		//----------------------------------------------------------------------
		//	Returns the height of the grid.
		grid2d_GetMaxY()
			return src.grid2d_cells.len/src.grid2d_X

		//----------------------------------------------------------------------
		//	Returns whether or not the grid contains the coordinates X,Y.
		grid2d_HasCoordinates(X,Y)
			if ( !isnum(X) || !isnum(Y) )	return FALSE
			if ( src.grid2d_DoesWrapX() )	X	= src.grid2d_GetWrapX(X)
			if ( src.grid2d_DoesWrapY() )	Y	= src.grid2d_GetWrapY(Y)
			if (X != round(X))				return FALSE
			if (Y != round(Y))				return FALSE
			if ( (X<1) || (Y<1) )			return FALSE
			if ( (X>src.grid2d_GetMaxX()) || (Y>src.grid2d_GetMaxY()) )
				return FALSE
			return TRUE
